﻿''' <summary>
''' Eine kleine GUI um die Möglichkeiten dieser Klasse zu demonstrieren.
''' </summary>
''' <remarks>Thomas Kriechbaumer</remarks>
Public Class frmMain
    Dim mHotkeyEnable As Boolean
    Dim WithEvents Hotkeys As clsHotkeys
    Private Const hk_StrgR As String = "StrgR"
    Private Const hk_WinR As String = "WinR"
    Private Const hk_ShiftQ As String = "ShiftQ"


    ''' <summary>
    ''' Setzt die Hotkeys, erstellt diese, oder löscht sie.
    ''' </summary>
    Public Property HotkeyEnable() As Boolean
        Get
            Return mHotkeyEnable
        End Get
        Set(ByVal value As Boolean)
            If Hotkeys Is Nothing Then Hotkeys = New clsHotkeys()

            If value Then
                Dim res As Boolean

                res = Hotkeys.TryAddHotKey(Keys.R, clsHotkeys.MODKEY.MOD_CONTROL, hk_StrgR)
                If Not res Then
                    MessageBox.Show("Hotkey " & hk_StrgR & " konnte nicht erstellt werden!")
                    Label1.Text = "Registrierung fehlgeschlagen: Strg + R"
                Else
                    Label1.Text = "Strg + R  erfolgreich registriert"
                End If
            
                res = Hotkeys.TryAddHotKey(Keys.R, clsHotkeys.MODKEY.MOD_WIN, hk_WinR)
                If Not res Then
                    MessageBox.Show("Hotkey " & hk_WinR & " konnte nicht erstellt werden!")
                    Label2.Text = "Registrierung fehlgeschlagen: Win + R"
                Else
                    Label2.Text = "Win + R  erfolgreich registriert"
                End If

                res = Hotkeys.TryAddHotKey(Keys.Q, clsHotkeys.MODKEY.MOD_SHIFT, hk_ShiftQ)
                If Not res Then
                    MessageBox.Show("Hotkey " & hk_ShiftQ & " konnte nicht erstellt werden!")
                    Label3.Text = "Registrierung fehlgeschlagen: Shift + Q"
                Else
                    Label3.Text = "Shift + Q  erfolgreich registriert"
                End If
            Else
                If Hotkeys IsNot Nothing Then
                    Hotkeys.RemoveHotKey(hk_StrgR)
                    Hotkeys.RemoveHotKey(hk_WinR)
                    Hotkeys.RemoveHotKey(hk_ShiftQ)
                End If
            End If

            mHotkeyEnable = value
            Me.Text = "Hotkeys aktiv: " & value
        End Set
    End Property

    ''' <summary>
    ''' wird ausgelöst, wenn ein Hotkey gedrück wurde
    ''' </summary>
    Private Sub Hotkeys_HotKeyPressed(ByVal HotKeyID As String) Handles Hotkeys.HotKeyPressed
        Select HotKeyID
            Case hk_StrgR
                MessageBox.Show("Dein Hotkey wurde ausgelöst! " & hk_StrgR)
            Case hk_WinR
                MessageBox.Show("Dein Hotkey wurde ausgelöst! " & hk_WinR)
            Case hk_ShiftQ
                MessageBox.Show("Dein Hotkey wurde ausgelöst! " & hk_ShiftQ)
        End Select
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        HotkeyEnable = True
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        HotkeyEnable = False
    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        HotkeyEnable = False
    End Sub
End Class
